Loading...
Searching...
No Matches
ServiceNowRestDataProvider::ServiceNowTableDataProvider Class Reference

The ServiceNowTableDataProvider data provider class. More...

`#include <ServiceNowTableDataProvider.qc.dox.h>`

Inheritance diagram for ServiceNowRestDataProvider::ServiceNowTableDataProvider:
[legend]

## Public Member Functions

| constructor (ServiceNowRestClient rest, string name, hash< auto > access, hash< auto > meta)
| Creates the object from the arguments.
string | getDesc ()
| Returns the data provider description.
string | getName ()
| Returns the data provider name.
Public Member Functions inherited from ServiceNowRestDataProvider::ServiceNowRestDataProviderBase
| constructor ()
| Creates the object.
| constructor (ServiceNowRestClient::ServiceNowRestClient rest)
| Creates the object.
| setLogger (*LoggerInterface logger)
| Accepts a LoggerInterface object for logging (or clears it)

## Public Attributes

hash< auto > | access
| Access description.
const | Expressions
| Supported expressions.
hash< auto > | meta
| Metadata description.
string | name
| Current object name.
const | SysColumns
| System columns.

## Protected Member Functions

*hash< auto > | createRecordImpl (hash< auto > rec, *hash< auto > create_options)
| Creates the given record to the data provider.
int | deleteRecordsImpl (*hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Deletes zero or more records.
| deleteSingleRecord (string id)
| deletes a single record
hash< DataProviderExpression > | getEqualityComparisonExpression (int role, hash< DataProviderInfo > info, string key, auto value)
| Returns an equality comparison expression.
| getRecordInfoIntern ()
| Retrieves the record type.
hash< DataProvider::DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
hash< ServiceNowRestRecordInfo > | record_info ()
| Record info for the table.
DataProvider::AbstractDataProviderRecordIterator | searchRecordsImpl (*hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options.
int | updateRecordsImpl (hash< auto > set, hash< DataProviderExpression > where_cond, *hash< auto > search_options)
| Updates zero or more records matching the search options.
| updateSingleRecord (string id, hash< auto > set)
| updates a single record

## Protected Attributes

string | uri_path = "table/"
| URI path prefix.
Protected Attributes inherited from ServiceNowRestDataProvider::ServiceNowRestDataProviderBase
ServiceNowRestClient::ServiceNowRestClient | rest
| The REST client object for API calls.

## Detailed Description

The ServiceNowTableDataProvider data provider class.

## Member Function Documentation

## createRecordImpl()

*hash< auto > ServiceNowRestDataProvider::ServiceNowTableDataProvider::createRecordImpl | ( | hash< auto > | rec,
|  | *hash< auto > | create_options
| ) |  |

protected

Creates the given record to the data provider.

Parameters

  rec | a hash representing a single input record
  create_options | the create options after processing by validateCreateOptions()

Returns
  the data written to the data provider with the `"id"` field of the new record

Exceptions

  DUPLICATE-RECORD | this exception should be thrown if the provider fails due to an attempt to create a duplicate record

## deleteRecordsImpl()

int ServiceNowRestDataProvider::ServiceNowTableDataProvider::deleteRecordsImpl | ( | *hash< DataProviderExpression > | where_cond,
|  | *hash< auto > | search_options
| ) |  |

protected

Deletes zero or more records.

Parameters

  where_cond | a hash for identifying the record(s) to be deleted
  search_options | the delete options after processing by validateSearchOptions()

Returns
  the number of records deleted

## searchRecordsImpl()

DataProvider::AbstractDataProviderRecordIterator ServiceNowRestDataProvider::ServiceNowTableDataProvider::searchRecordsImpl | ( | *hash< auto > | where_cond,
|  | *hash< auto > | search_options
| ) |  |

protected

Returns an iterator for zero or more records matching the search options.

Parameters

  where_cond | the search criteria
  search_options | the search options after processing by validateSearchOptions()

See also
  requestSearchRecordsImpl()

## updateRecordsImpl()

int ServiceNowRestDataProvider::ServiceNowTableDataProvider::updateRecordsImpl | ( | hash< auto > | set,
|  | hash< DataProviderExpression > | where_cond,
|  | *hash< auto > | search_options
| ) |  |

protected

Updates zero or more records matching the search options.

Parameters

  set | the hash of field data to set
  where_cond | a hash for identifying the record(s) to be updated
  search_options | the update options after processing by validateSearchOptions()

Returns
  the number of records updated